'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _rng = require('./rng');

var _rng2 = _interopRequireDefault(_rng);

var _xor = require('./generators/xor128');

var _xor2 = _interopRequireDefault(_xor);

var _function = require('./generators/function');

var _function2 = _interopRequireDefault(_function);

var _mathRandom = require('./generators/math-random');

var _mathRandom2 = _interopRequireDefault(_mathRandom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PRNG_BUILTINS = {
  // TODO: add more prng from C++11 lib
  'xor128': _xor2.default,
  'function': _function2.default,
  'default': _mathRandom2.default
};

exports.default = function () {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var _args$ = args[0],
      arg0 = _args$ === undefined ? 'default' : _args$,
      rest = args.slice(1);


  switch (typeof arg0 === 'undefined' ? 'undefined' : (0, _typeof3.default)(arg0)) {
    case 'object':
      if (arg0 instanceof _rng2.default) {
        return arg0;
      }
      break;

    case 'function':
      return new _function2.default(arg0);

    case 'string':
      var PRNG = PRNG_BUILTINS[arg0];
      if (PRNG) {
        return new (Function.prototype.bind.apply(PRNG, [null].concat((0, _toConsumableArray3.default)(rest))))();
      }
      break;
  }

  throw new Error('invalid RNG "' + arg0 + '"');
};
//# sourceMappingURL=rng-factory.js.map